package ovh.herisson.Clyde;

import org.hibernate.HibernateException;
import org.hibernate.engine.jdbc.connections.spi.JdbcConnectionAccess;
import org.hibernate.engine.spi.SessionImplementor;
import org.hibernate.engine.spi.SharedSessionContractImplementor;
import org.hibernate.id.IdentifierGenerator;

import java.io.Serializable;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class RegNoGenerator implements IdentifierGenerator {
    @Override
    public Object generate(SharedSessionContractImplementor session, Object object) {
        try{
            JdbcConnectionAccess jdbccon = session.getJdbcConnectionAccess();
            Connection conn = jdbccon.obtainConnection();

            Statement statement = conn.createStatement();
            String query = "select count(reg_no)+1 from Users";

            ResultSet set = statement.executeQuery(query);

            if (set.next()){
                return set.getLong(1)+1000;
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
        return null;
    }
}
